package fr.unice.javinspector.GUI.main;

import javax.swing.JFrame;
import java.awt.HeadlessException;
import javax.swing.ImageIcon;
import javax.swing.JPanel;
import java.awt.BorderLayout;
import javax.swing.JLabel;
import java.awt.Color;
import java.awt.FlowLayout;
import javax.swing.JWindow;
import java.awt.Dimension;
import java.awt.event.MouseAdapter;
import java.awt.Toolkit;
import java.awt.event.MouseEvent;
import java.awt.Frame;
import javax.swing.SwingUtilities;

/**
 * <p>Title: Class LogoFrame</p>
 * <p>Description: This class is the starting window of the application</p>
 * <p>Company: UNSA</p>
 * @author APPIETTO Christophe - ARNAUD Jean-Michel - EL MAHRATI Hassan
 * @version 1.2
 */

public class LogoFrame extends JWindow {
  private ImageIcon logo = new ImageIcon(LogoFrame.class.getResource("/imgs/logoji.gif"));
  private JPanel panel = new JPanel();
  private JPanel panelDown = new JPanel();

  /**
   * The contructor
   * @param f
   * @param waitTime
   * @throws HeadlessException
   */
  public LogoFrame(Frame f, int waitTime) throws HeadlessException {
    super(f);
    this.setFocusableWindowState(false);
    BorderLayout layout = new BorderLayout();
    layout.setVgap(0);
    panel.setLayout(layout);
    JLabel labelLogo = new JLabel(logo);
    panel.add(labelLogo, BorderLayout.CENTER);
    FlowLayout layout2 = new FlowLayout();
    layout2.setAlignment(FlowLayout.LEFT);
    panelDown.setLayout(layout2);
    panelDown.setBackground(Color.WHITE);
    panelDown.add(new JLabel("Initializing ..."));
    panel.add(panelDown, BorderLayout.SOUTH);
    this.getContentPane().add(panel, BorderLayout.CENTER);
    this.pack();

    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = this.getSize();
    this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    addMouseListener(new MouseAdapter(){
      public void mousePressed(MouseEvent e){
        setVisible(false);
        dispose();
      }
    });

    final int pause = waitTime;
    final Runnable closerRunner = new Runnable(){
      public void run(){
        setVisible(false);
        dispose();
      }
    };
    Runnable waitRunner = new Runnable()
    {
      public void run(){
        try{
          Thread.sleep(pause);
          SwingUtilities.invokeAndWait(closerRunner);
        }
        catch(Exception e){
          e.printStackTrace();
        }
      }
    };
    setVisible(true);
    Thread splashThread = new Thread(waitRunner, "SplashThread");
    splashThread.start();
  }
}
