package fr.unice.javinspector.GUI.search;

import java.awt.*;
import java.util.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.text.*;
import java.lang.reflect.*;
import javax.swing.border.*;
import fr.unice.javinspector.util.*;
import fr.unice.javinspector.GUI.util.*;
import fr.unice.javinspector.GUI.search.*;
import fr.unice.javinspector.core.analyser.*;
import fr.unice.javinspector.core.engineSearch.*;
import fr.unice.javinspector.core.engineSearch.advancedEngineSearch.*;
import fr.unice.javinspector.core.engineSearch.advancedEngineSearch.parser.*;



/**
 * <p>Title: AdvancedSearch</p>
 * <p>Description: this class provide a JPanel where an Advanced search GUI
 * is implemented. </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: UNICE </p>
 * @author Zerbib Gabriel - Charbit Lucas - Galbois Xavier - Gahide Jrme
 * @version 1.0
 */
public class AdvancedSearch extends JPanel{

  private static JTextPaneAutoStyled exprSaisieTextTemp;

  private AdvancedEngineSearch advSearch;
  private JPanel mainPanel = new JPanel();
  private VerticalFlowLayout vflMainPanel = new VerticalFlowLayout();
  private JPanel expressionSaisiePanel = new JPanel();
  private JPanel additionnalComponentPanel = new JPanel();
  private JPanel criterionPanel = new JPanel();
//  private JTextArea exprSaisieText = new JTextArea();
  private Hashtable dicoWS= new Hashtable();
  private JTextPaneAutoStyled exprSaisieText = new JTextPaneAutoStyled(dicoWS);
  private JPanel optionPanel = new JPanel();


  // bidouille pour les actions performed
  protected static JButton staticButton;
  private VerticalFlowLayout verticalFlowLayout1 = new VerticalFlowLayout();
  private JButton submitButton = new JButton();
  private GridLayout gridLayout1 = new GridLayout();
  private VerticalFlowLayout verticalFlowLayout2 = new VerticalFlowLayout();

  private JTabbedPane tabbedPaneResRef;
  private Border border1;
  private TitledBorder titledBorder1;

  private SearchWindow jdialogRef;

  private static int i = 0;
  private JPanel operatorsPanel = new JPanel();
  private JButton jBnot = new JButton();
  private JButton jBparenR = new JButton();
  private JButton jBparentL = new JButton();
  private JButton jBand = new JButton();
  private JButton jBor = new JButton();
  private JButton jBclear = new JButton();

  /**
   * Construct a new Advanced Search GUI based on the aes
   * and the parent JFrame cp.
   * @param aes the initialised AdvancedEngineSearch
   * @param cp the parent JFrame
   * @param dialog rthe search windows
   */
  public AdvancedSearch(AdvancedEngineSearch aes, JTabbedPane cp, SearchWindow dialog ) {
    this.advSearch = aes;
    this.tabbedPaneResRef= cp;
    this.jdialogRef = dialog;
    // buid the GUI
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }

    // construct the GUI inside

    // add the criterion button for each criterion of the adv search given
    // in Parameter.
    buildCriterionButton();

    // un petit test

    JTextPaneAutoStyled test = new JTextPaneAutoStyled(new Hashtable());
   // this.add(test);


  }
  private void jbInit() throws Exception {
    border1 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(148, 145, 140));
    titledBorder1 = new TitledBorder(border1,"Write your query");
    mainPanel.setBackground(Color.gray);
    mainPanel.setMinimumSize(new Dimension(300, 400));
    mainPanel.setPreferredSize(new Dimension(300, 400));
    mainPanel.setLayout(vflMainPanel);
    vflMainPanel.setHgap(0);
    vflMainPanel.setVgap(0);
    exprSaisieText.setBorder(titledBorder1);
    exprSaisieText.setMinimumSize(new Dimension(280, 34));
    exprSaisieText.setPreferredSize(new Dimension(280, 60));
    exprSaisieTextTemp = exprSaisieText;
    exprSaisieText.addKeyListener(new java.awt.event.KeyListener() {
      private JTextPaneAutoStyled exprSaisieTextLocal = exprSaisieTextTemp;
      public void keyTyped(KeyEvent e){

      }

      public void keyPressed(KeyEvent e){
        if ( e.getKeyCode() == KeyEvent.VK_ENTER ){
          System.err.println("la touche entre");
          Document doc = exprSaisieTextLocal.getDocument();

            String toto = exprSaisieTextLocal.getText();
            StringTokenizer st  = new StringTokenizer(toto,"\n");
            String res = "";
            while(st.hasMoreTokens()){
              res += st.nextToken();
            }

            exprSaisieTextLocal.setText(res);
//            System.out.print(exprSaisieTextLocal.getText());
//            System.out.println(":end");
            // lunch the search
            submitButton_actionPerformed(null);
        }

      }
      public void keyReleased(KeyEvent e){

      }

    });

    expressionSaisiePanel.setMinimumSize(new Dimension(214, 50));
    expressionSaisiePanel.setPreferredSize(new Dimension(290, 120));
    expressionSaisiePanel.setLayout(verticalFlowLayout1);
    submitButton.setMaximumSize(new Dimension(73, 20));
    submitButton.setPreferredSize(new Dimension(50, 24));
    submitButton.setMargin(new Insets(0, 0, 0, 0));
    submitButton.setText("submit");
    submitButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        submitButton_actionPerformed(e);
      }
    });
    verticalFlowLayout1.setAlignment(FlowLayout.CENTER);
    verticalFlowLayout1.setVgap(10);
    verticalFlowLayout1.setHorizontalFill(false);
    criterionPanel.setLayout(gridLayout1);
    gridLayout1.setColumns(4);
    gridLayout1.setRows(7);
    this.setLayout(verticalFlowLayout2);
    this.setBackground(Color.gray);
    this.setMinimumSize(new Dimension(300, 300));
    this.setPreferredSize(new Dimension(300, 360));
    verticalFlowLayout2.setHgap(0);
    verticalFlowLayout2.setVgap(0);
    verticalFlowLayout2.setHorizontalFill(false);
    additionnalComponentPanel.setPreferredSize(new Dimension(296, 100));
    criterionPanel.setPreferredSize(new Dimension(300, 120));
    jBnot.setMaximumSize(new Dimension(45, 20));
    jBnot.setMinimumSize(new Dimension(45, 20));
    jBnot.setPreferredSize(new Dimension(45, 20));
    jBnot.setMargin(new Insets(0, 7, 0, 7));
    jBnot.setText("not");
    jBnot.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jBnot_actionPerformed(e);
      }
    });
    jBparenR.setMaximumSize(new Dimension(28, 20));
    jBparenR.setMinimumSize(new Dimension(28, 20));
    jBparenR.setPreferredSize(new Dimension(28, 20));
    jBparenR.setMargin(new Insets(0, 7, 0, 7));
    jBparenR.setText(")");
    jBparenR.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jBparenR_actionPerformed(e);
      }
    });
    jBparentL.setMaximumSize(new Dimension(28, 20));
    jBparentL.setMinimumSize(new Dimension(28, 20));
    jBparentL.setPreferredSize(new Dimension(28, 20));
    jBparentL.setMargin(new Insets(0, 7, 0, 7));
    jBparentL.setText("(");
    jBparentL.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jBparentL_actionPerformed(e);
      }
    });
    jBand.setMaximumSize(new Dimension(43, 20));
    jBand.setMinimumSize(new Dimension(43, 20));
    jBand.setPreferredSize(new Dimension(43, 20));
    jBand.setMargin(new Insets(0, 7, 0, 7));
    jBand.setText("and");
    jBand.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jBand_actionPerformed(e);
      }
    });
    jBor.setMaximumSize(new Dimension(40, 20));
    jBor.setMinimumSize(new Dimension(40, 20));
    jBor.setPreferredSize(new Dimension(40, 20));
    jBor.setMargin(new Insets(0, 7, 0, 7));
    jBor.setText("or");
    jBor.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jBor_actionPerformed(e);
      }
    });
    operatorsPanel.setPreferredSize(new Dimension(300, 30));
    jBclear.setMaximumSize(new Dimension(60, 20));
    jBclear.setMinimumSize(new Dimension(60, 20));
    jBclear.setPreferredSize(new Dimension(60, 20));
    jBclear.setMargin(new Insets(0, 7, 0, 7));
    jBclear.setText("clear");
    jBclear.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jBclear_actionPerformed(e);
      }
    });
    this.add(mainPanel, null);
    mainPanel.add(expressionSaisiePanel, null);
    JScrollPane js = new JScrollPane();
    js.getViewport().add(exprSaisieText);
    expressionSaisiePanel.add(js, null);
    expressionSaisiePanel.add(submitButton, null);
    mainPanel.add(additionnalComponentPanel, null);
    mainPanel.add(operatorsPanel, null);
    mainPanel.add(criterionPanel, null);
    mainPanel.add(optionPanel, null);
    operatorsPanel.add(jBor, null);
    operatorsPanel.add(jBand, null);
    operatorsPanel.add(jBparentL, null);
    operatorsPanel.add(jBparenR, null);
    operatorsPanel.add(jBnot, null);
    operatorsPanel.add(jBclear, null);
  }

  /**
   * Add a button to the GUI for each citerion that is in the AdvencedSearch.
   */
  private void buildCriterionButton(){

    Hashtable tmp = advSearch.getCriterion();
    for (Enumeration e = tmp.elements() ; e.hasMoreElements() ;) {
      Criterion tmpC = (Criterion)e.nextElement();
      JButton buttonCriterion = new JButton(tmpC.getName());
      staticButton = buttonCriterion;
      criterionPanel.add(buttonCriterion);
      // also add a style to the text printed by this button
      // to the textPane.
      dicoWS.put(tmpC.getName(),"criterion");

      if(!tmpC.isAdditionnalGraphicsComponent().isEmpty())
        buildAdditionnalComponent(tmpC.isAdditionnalGraphicsComponent());

      buttonCriterion.addActionListener(new java.awt.event.ActionListener() {

        String name = staticButton.getText();

        public void actionPerformed(ActionEvent e) {
          Document doc = exprSaisieText.getDocument();
          try {
            doc.insertString(doc.getLength(), name +" ",
                             exprSaisieText.getStyle("regular"));
          }
          catch (BadLocationException ex) {
            ex.printStackTrace();
          }
        }
      });
    }

  }

  /**
   * Called when some additionnal composent exists in a criterion that is
   * in the advsearch.
   * @param l the ArrayList of the additionnal composent to add
   */
  private void buildAdditionnalComponent(ArrayList l){
    Iterator iter = l.iterator();
    while (iter.hasNext()) {
      Component item = (Component)iter.next();
      additionnalComponentPanel.add(item);
    }
  }

  /**
   * Action when the cancel button is cliqued
   * @param e the action event
   */

  /**
   * Action when the submit button is cliqued
   * @param e the action event
   */
  void submitButton_actionPerformed(ActionEvent e) {
    // check the valu of the combo

    String classInsp = (String)jdialogRef.getSs().getChoiceCombo().getSelectedItem();
    if(classInsp.compareTo("All Classifier")==0){
      advSearch.setInspector(jdialogRef.getCurrentInspector());
    }else{
      // set the the classifier to search in.
      ClassifierAnalyser caTmp = jdialogRef.getCurrentInspector().getClassifierAnalyser(classInsp);
      advSearch.setClassifierAnalyser(caTmp);
    }


    try {
      advSearch.setExpression(exprSaisieText.getText());
      ArrayList res = advSearch.search();

      // print ...
      Iterator iter = res.iterator();
      while (iter.hasNext()) {
        Member item = (Member)iter.next();
//        System.out.println(item);
      }

      ResultSearch rs = new ResultSearch(res);
      tabbedPaneResRef.addTab("advSearch "+i,rs); //, icone
      i++;
      tabbedPaneResRef.setSelectedIndex(tabbedPaneResRef.getTabCount()-1);

      jdialogRef.setVisible(false);
      jdialogRef.getmain().showResultPanel(true);
    }
    catch (ParseException ex) {
      //ex.printStackTrace();
      JOptionPane.showMessageDialog(this,
                                    "The request writed is invalid",
                                    "Request Error."
                                    ,JOptionPane.ERROR_MESSAGE);


    }

  }

  void jBor_actionPerformed(ActionEvent e) {
    Document doc = exprSaisieText.getDocument();
    try {
      doc.insertString(doc.getLength(), "OR ",
                       exprSaisieText.getStyle("regular"));
    }
    catch (BadLocationException ex) {
      ex.printStackTrace();
    }


  }

  void jBand_actionPerformed(ActionEvent e) {
    Document doc = exprSaisieText.getDocument();
   try {
     doc.insertString(doc.getLength(), "AND ",
                      exprSaisieText.getStyle("regular"));
   }
   catch (BadLocationException ex) {
     ex.printStackTrace();
    }

  }

  void jBparentL_actionPerformed(ActionEvent e) {
    Document doc = exprSaisieText.getDocument();
   try {
     doc.insertString(doc.getLength(), "( ",
                      exprSaisieText.getStyle("regular"));
   }
   catch (BadLocationException ex) {
     ex.printStackTrace();
    }
  }

  void jBparenR_actionPerformed(ActionEvent e) {
    Document doc = exprSaisieText.getDocument();
   try {
     doc.insertString(doc.getLength(), ") ",
                      exprSaisieText.getStyle("regular"));
   }
   catch (BadLocationException ex) {
     ex.printStackTrace();
    }

  }

  void jBnot_actionPerformed(ActionEvent e) {
    Document doc = exprSaisieText.getDocument();
   try {
     doc.insertString(doc.getLength(), "NOT ",
                      exprSaisieText.getStyle("regular"));
   }
   catch (BadLocationException ex) {
     ex.printStackTrace();
    }
  }

  void jBclear_actionPerformed(ActionEvent e) {
    exprSaisieText.setText("");
  }


}
