package fr.unice.javinspector.GUI.search;

import java.util.ArrayList;
import java.lang.reflect.Member;
import java.lang.reflect.Modifier;
import javax.swing.JComboBox;
import javax.swing.JPanel;
import javax.swing.JButton;
import javax.swing.BorderFactory;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import fr.unice.javinspector.GUI.util.VerticalFlowLayout;
import fr.unice.javinspector.core.engineSearch.*;
import javax.swing.JLabel;

/**
 * <p>Title: NameCriterion</p>
 * <p>Description: This criterion test the name of the member.</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: UNICE</p>
 * @author Zerbib Gabriel - Charbit Lucas - Galbois Xavier - Gahide Jrme
 * @version 1.0
 */

public class NameCriterion extends Criterion {

  private String nameToCompareWith;

  private JComboBox searchText = new JComboBox();
  private JPanel jPanel1 = new JPanel();
  private VerticalFlowLayout verticalFlowLayout1 = new VerticalFlowLayout();
  private JLabel nameofSearch = new JLabel();


  /**
   * Construct a new instance of this criterion.
   * This overwrite the name of the criterion
   * This also add additionnal component to take graphicaly the name search.
   */
  public NameCriterion() {
    name = "name";
    nameToCompareWith = "";

    // add a component
    JPanel moreGraphics = new JPanel();
    searchText.setEditable(true);
    searchText.addItem(new String("Input a pattern to search"));
    searchText.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        ValidateQuery_actionPerformed(e);
      }
    });



    nameofSearch.setFont(new java.awt.Font("Serif", 1, 11));
    nameofSearch.setText("name of the method, var to search");

    verticalFlowLayout1.setHgap(10);
    jPanel1.setLayout(verticalFlowLayout1);

    jPanel1.add(nameofSearch, null);
    jPanel1.add(searchText, null);

    moreGraphics.add(jPanel1);
    AdditionalComponent.add(moreGraphics);


  }

  /**
   * Set the name that we want the criterion compare with.
   * @param name
   */
  public void setNameToCompare(String name){
    nameToCompareWith = name;
  }

  /**
   * test if the member matches to this criterion.
   * @param m the member that we want to check the validity.
   * @return true if the Criterion is Valid for this Member
   * @throws SearchEngineException
   */
  public boolean isCriterionValid(Member m)
      throws SearchEngineException{

    if( isActive == EngineSearchConst.NOT){
      if( !(m.getName().compareTo(nameToCompareWith) == 0) )
        return true;
      else
        return false;
     }
     else if( isActive == EngineSearchConst.YES){
       if( m.getName().compareTo(nameToCompareWith) == 0 )
         return true;
       else
         return false;
     }
     else if( isActive == EngineSearchConst.DONTMIND){
       // if i don't mind of the result, I always return true
       // logic !!
       return true;
     }
     else{
       throw new SearchEngineException("isCriterionValid : Name Criterion : ");
     }

  }

  /**
  * Here we add a Jcombobox to take the string to compare with.
  * @return Empty if there no additionnal graphics component for a criterion
  * @since 2.0
  */
 public ArrayList isAdditionnalGraphicsComponent(){
   return AdditionalComponent;
 }

 /**
  * action performed when the search button is cliqued and so
  * a new query submitted.
  * @param e the Action event
  * @throws SearchException
  */
 private void ValidateQuery_actionPerformed(ActionEvent e){

   this.setNameToCompare((String)searchText.getSelectedItem());


   // memory of the search for the combo box
   if(searchText.getSelectedIndex() == -1){
     searchText.addItem(searchText.getSelectedItem());
   }


 }
}
