package fr.unice.javinspector.GUI.search;

import java.util.ArrayList;

import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.event.TreeSelectionListener;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.tree.TreeSelectionModel;
import java.net.URL;
import java.io.IOException;
import java.awt.*;
import java.awt.event.*;
import java.util.Iterator;
import java.lang.reflect.Member;
import java.util.StringTokenizer;
import fr.unice.javinspector.core.analyser.ClassifierAnalyser;
import fr.unice.javinspector.core.engineSearch.*;
import fr.unice.javinspector.core.engineSearch.advancedEngineSearch.*;
import javax.swing.*;
import javax.swing.border.*;

/**
 * <p>Title: resultSearch</p>
 * <p>Description: this class provide a panel to format his results
 * search on classifier. </p>
 * <p>Copyright : UNICE</p>
 * @author Zerbib Gabriel - Charbit Lucas - Galbois Xavier - Gahide Jrme
 * @version 1.0
 */
public class ResultSearch extends JPanel{

  ArrayList listResultMember;

  private DefaultMutableTreeNode racine;
  private JTree resultTree = new JTree();
  private TreeCellRendererResultSearchView tcrrsv = new TreeCellRendererResultSearchView();

 // private JPanel mainPanel = new JPanel();
  private JScrollPane jScrollPane;
  private BorderLayout borderLayout1 = new BorderLayout();
  private Border border1;

  /**
   * Construct a new GUI representation of a result search in a JPanel
   * The search can be Advanced or not.
   * NB : we do not verifie what's in the ArrayList.
   * @param listMember tha ArrayList of Member that are the result of a search
   */
  public ResultSearch(ArrayList listMember) {
    this.listResultMember = listMember;

    String racineText;
    // construc the JTree
    if( listMember.isEmpty()){
      racineText = "No result found";
    }else{
      racineText = "resultSearch";
    }
    racine = new DefaultMutableTreeNode(racineText);
    resultTree = new JTree(racine);
    resultTree.setCellRenderer(tcrrsv);
    buildHiearchy(listResultMember);
    // build th GUI
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }


  private void jbInit() throws Exception {
    jScrollPane = new JScrollPane(resultTree);
    border1 = BorderFactory.createCompoundBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED,Color.white,Color.white,new Color(103, 101, 98),new Color(148, 145, 140)),BorderFactory.createEmptyBorder(5,5,5,5));
    jScrollPane.setBorder(null);
    jScrollPane.setPreferredSize(new Dimension(400, 300));
    this.setLayout(borderLayout1);
    this.setBackground(Color.WHITE);
    this.setBorder(border1);
//    jScrollPane.getViewport().add(resultTree, null);
    this.add(jScrollPane, BorderLayout.CENTER);
  }

  /**
   * Construct a JTree with the ArrayList.
   * if l is empty or null, the function return immediately.
   * This Jtree is organised y class, method field construct , and by name.
   * @param l the ArrayList data.
   */
  public void buildHiearchy(ArrayList l){
    if( l == null || l.isEmpty() )
      return;
    String className = ((Member)l.get(0)).getDeclaringClass().getName();
    DefaultMutableTreeNode classCat = new DefaultMutableTreeNode(className);
    DefaultMutableTreeNode currentSubCat = null;
    String subCatName ="";
    racine.add(classCat);

    Iterator iter = l.iterator();
    while (iter.hasNext()) {
      Member item = (Member)iter.next();

      // check for the next class
      String compare = item.getDeclaringClass().getName();

      if( className.compareTo(compare) == 0){
        String shortName = ClassifierAnalyser.shortName(item.getClass().getName());
        // check for method, Constrc...
        if( currentSubCat == null ||
            subCatName.compareTo(shortName) != 0){
          currentSubCat = new DefaultMutableTreeNode(shortName);
          classCat.add(currentSubCat);
          subCatName = shortName;
        }
        // add the leaf
        currentSubCat.add(new DefaultMutableTreeNode(item));



      }else{

        className = compare;
        classCat = new DefaultMutableTreeNode(className);
        racine.add(classCat);
        // reinitialisation of the sub node
        // we can do all that cause we know that is possible
        String shortName = ClassifierAnalyser.shortName(item.getClass().getName());
        currentSubCat = new DefaultMutableTreeNode(shortName);
        classCat.add(currentSubCat);
        subCatName = shortName;
        currentSubCat.add(new DefaultMutableTreeNode(item));

      }

    }
  }


}
