package fr.unice.javinspector.GUI.search;

import javax.swing.tree.TreeCellRenderer;
import java.awt.Component;
import javax.swing.JTree;
import java.awt.Color;
import javax.swing.JLabel;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.ImageIcon;
import fr.unice.javinspector.GUI.util.TreeCellRendererHeritageView;
import java.lang.reflect.Member;
import java.lang.reflect.Modifier;
import fr.unice.javinspector.GUI.util.IconBank;

/**
 * <p>Title: TreeCellRendererResultSearchView</p>
 * <p>Description: This is a model for the result search panel tree.</p>
 * <p>Company: UNSA </p>
 * @author Zerbib Gabriel - Charbit Lucas - Galbois Xavier - Gahide Jrme
 * @version 1.0
 */

public class TreeCellRendererResultSearchView implements TreeCellRenderer {

  private JLabel renderer;

  public TreeCellRendererResultSearchView() {
    renderer = new JLabel();
    renderer.setOpaque(true);
  }

  public Component getTreeCellRendererComponent(JTree tree, Object value, boolean selected,
                                                boolean expanded, boolean leaf, int row,
                                                boolean hasFocus) {
    Color background = selected ? Color.YELLOW : Color.WHITE;
    renderer.setBackground(background);
    DefaultMutableTreeNode dmtn = (DefaultMutableTreeNode) value;

    if(leaf && !dmtn.isRoot()) {
//      if(leaf && ((DefaultMutableTreeNode)value).getUserObject() instanceof Member ) {
      if( dmtn.getUserObject() instanceof String){

      }else{
        Member valueMember = ((Member)((DefaultMutableTreeNode)value).getUserObject());
        if (dmtn.getParent().toString().trim().compareTo("Constructor") == 0){
          renderer.setIcon(IconBank.getConstructorIcon(valueMember.getModifiers()));
        }
        else if (dmtn.getParent().toString().trim().compareTo("Method") == 0){
          renderer.setIcon(IconBank.getMethodIcon(valueMember.getModifiers()));
        }

        else if (dmtn.getParent().toString().trim().compareTo("Field") == 0){
          renderer.setIcon(IconBank.getFieldIcon(valueMember.getModifiers()));
        }
        else {

        }
        renderer.setText(valueMember.toString());
      }

    }
    else {
      String valueName = ((String)((DefaultMutableTreeNode)value).getUserObject());
      if(valueName.compareTo("resultSearch") == 0) {
        renderer.setIcon(new ImageIcon(TreeCellRendererHeritageView.class.getResource("/imgs/racine.gif")));
        renderer.setText((String)((DefaultMutableTreeNode)value).getUserObject());
      }
      else if(valueName.compareTo("No result found") == 0) {
        renderer.setIcon(new ImageIcon(TreeCellRendererHeritageView.class.getResource("/imgs/fermer.gif")));
        renderer.setText((String)((DefaultMutableTreeNode)value).getUserObject());
      }
      else {
//        renderer.setIcon(IconBank.getClassIcon());
        renderer.setIcon(new ImageIcon(TreeCellRendererHeritageView.class.getResource("/imgs/classnode.gif")));
        renderer.setText((String)((DefaultMutableTreeNode)value).getUserObject());
      }
    }

    return renderer;
  }
}
