package fr.unice.javinspector.GUI.util;

import javax.swing.JButton;
import java.awt.Color;
import javax.swing.BorderFactory;
import java.awt.Insets;
import javax.swing.SwingConstants;
import java.awt.Dimension;
import javax.swing.border.*;
import javax.swing.JPanel;
import java.util.ArrayList;
import javax.swing.Box;
import java.awt.BorderLayout;
import javax.swing.JComboBox;
import java.awt.Font;
import java.awt.event.MouseListener;

/**
 * <p>Title: Class CustomButton</p>
 * <p>Description: This class create a custom JButton, used in the Compostion view</p>
 * <p>Copyright: UNICE</p>
 * <p>Company: </p>
 * @author Charbit Lucas - Gahide Jrome - Galbois Xavier - Zerbib Gabriel
 * @version 1.0
 */

public class CustomButton extends JButton {
  private static int STD_BUTTON_WIDTH = 150;
  private static int STD_BUTTON_HEIGHT = 25;
  private static int CUS_BUTTON_WIDTH = 150;
  private static int CUS_BUTTON_HEIGHT = 20;
  private Class classe;
  private String name;

  /**
   * The consructor, this function create a JButton with teh selected text, color, border etc.
   * @param isStatic : can this button be clicked
   * @param myClass : the class repreented by the JButton
   * @param text : the text of the JButton
   * @param color : the background color of the JButton
   * @param border : the border for te JButton
   */
  public CustomButton(boolean isStatic, Class myClass, String text, Color color,
                      boolean border) {
    super(text);
    this.setFont(new Font("Courier", Font.BOLD, 12));
    this.setBackground(color);
    this.setFocusPainted(false);
    this.setBorder(BorderFactory.createLineBorder(Color.black));
    this.setBorderPainted(border);
    this.classe = myClass;
    name = myClass.getName();
    if (!classe.isPrimitive()) {
      this.setToolTipText("Double click to open the heritage view for " +
                          classe.getName());
    }
    if (classe.isPrimitive()) {
      this.setToolTipText(classe.getName() + " is a primitive type");
    }
    if (isStatic) {
      this.setFont(new java.awt.Font("Dialog", 1, 13));
    }
    this.setHorizontalTextPosition(SwingConstants.CENTER);
    this.setActionCommand("CustomButton");
  }

  /**
   * return the class assoiated with this JButton
   * @return : the class
   */
  public Class getClasse() {
    return classe;
  }
}
