package fr.unice.javinspector.MVC.controler;

import java.awt.event.*;
import javax.swing.*;
import java.io.File;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Iterator;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import fr.unice.javinspector.GUI.util.CustomButton;
import javax.swing.filechooser.*;
import fr.unice.javinspector.core.XML.SaveFileXML;
import fr.unice.javinspector.core.XML.XMLFilter;
import fr.unice.javinspector.MVC.view.View;
import fr.unice.javinspector.MVC.manager.Manager;
import fr.unice.javinspector.MVC.view.DetailView;
import fr.unice.javinspector.MVC.view.GraphDetailView;
import fr.unice.javinspector.core.analyser.ClassifierAnalyser;
import fr.unice.javinspector.GUI.util.VerticalFlowLayout;
import java.awt.Color;

/**
 *
 * <p>Title: GraphDetailControler </p>
 * <p>Description: this class is the controler of GraphDetailView</p>
 * <p>Company: UNICE</p>
 * @author Lucas Charbit - Jerome Gahide - Galbois Xavier - Gabriel Zerbib
 * @version 1.0
 */
public class GraphDetailControler extends DetailControler
    implements ActionListener, MouseListener {
  private JPopupMenu jPopupMenu;
  boolean bool = false;
  public File file;
  /**
   * empty constructor
   */
  public GraphDetailControler() {}
  /**
   * construtor with 2 parameters
   * @param m the manager of this controler
   * @param gdv the view assiociated to this controler
   */
  public GraphDetailControler(Manager m, View gdv) {
    detailView = (DetailView)gdv;
    manager = m;
    createJPopupMenu();
    listenToView();
  }
  /**
   * get the name of this Class
   * @return the name of this Class
   */
  public String getName() {
    return this.getClass().getName();
  }
  /**
   * this function put the listener to the view of this controler
   */
  public void listenToView() {
    MouseListener popupListener = new PopupListener();
    ((GraphDetailView)detailView).getCenterPanel().addMouseListener(popupListener);
    // static methods
    ((GraphDetailView)detailView).getJCheckBoxStaticMethods().addActionListener(this);
    ((GraphDetailView)detailView).getJCheckBoxStaticMethods().setActionCommand("CheckBox");
    // abstract methods
    ((GraphDetailView)detailView).getJCheckBoxAbstractMethod().addActionListener(this);
    ((GraphDetailView)detailView).getJCheckBoxAbstractMethod().setActionCommand("CheckBox");
    // getter methods
    ((GraphDetailView)detailView).getJCheckBoxGetterMethods().addActionListener(this);
    ((GraphDetailView)detailView).getJCheckBoxAbstractMethod().setActionCommand("CheckBox");
    // setter methods
    ((GraphDetailView)detailView).getJCheckBoxSetterMethods().addActionListener(this);
    ((GraphDetailView)detailView).getJCheckBoxAbstractMethod().setActionCommand("CheckBox");
    // redefined methods
    ((GraphDetailView)detailView).getJCheckBoxRedefinedMethods().addActionListener(this);
    ((GraphDetailView)detailView).getJCheckBoxAbstractMethod().setActionCommand("CheckBox");
    // internal classes
    ((GraphDetailView)detailView).getJCheckBoxInternalClasses().addActionListener(this);
    ((GraphDetailView)detailView).getJCheckBoxAbstractMethod().setActionCommand("CheckBox");
    // fields
    ((GraphDetailView)detailView).getJCheckBoxFields().addActionListener(this);
    ((GraphDetailView)detailView).getJCheckBoxAbstractMethod().setActionCommand("CheckBox");
    // static fields
    ((GraphDetailView)detailView).getJCheckBoxStaticFields().addActionListener(this);
    ((GraphDetailView)detailView).getJCheckBoxAbstractMethod().setActionCommand("CheckBox");
    // constructors
    ((GraphDetailView)detailView).getJCheckBoxConstructors().addActionListener(this);
    ((GraphDetailView)detailView).getJCheckBoxAbstractMethod().setActionCommand("CheckBox");
    // methods
    ((GraphDetailView)detailView).getJCheckBoxMethods().addActionListener(this);
    ((GraphDetailView)detailView).getJCheckBoxAbstractMethod().setActionCommand("CheckBox");

    ArrayList listenedJButtons = ((GraphDetailView)detailView).getListenedJButtons();
    for(int i=0; i<listenedJButtons.size(); i++) {
      ((JButton)listenedJButtons.get(i)).addMouseListener(this);
    }
  }
  /**
   * this function create the JPopupMenu of the view
   */
  public void createJPopupMenu() {
    jPopupMenu = new JPopupMenu("Options");
    JMenuItem menuItem = new JMenuItem("Save as ...");
    menuItem.setIcon(new ImageIcon(GraphDetailControler.class.
                                   getResource("/imgs/save.gif")));
    menuItem.addActionListener(this);
    menuItem.setActionCommand("MenuItem");
    jPopupMenu.add(menuItem);
    menuItem = new JMenuItem("Refresh view");
    menuItem.setIcon(new ImageIcon(GraphDetailControler.class.
                                   getResource("/imgs/refresh.gif")));
    menuItem.setActionCommand("MenuItem");
    menuItem.addActionListener(this);
    jPopupMenu.add(menuItem);
  }
  /**
   * this function says to the manager if the view can be controled
   * @param v the view
   * @return true if the view can be controled
   */
  public boolean isControlable(View v) {
    String shortViewName = v.getName().substring(v.getName().lastIndexOf("."), v.getName().length());
    if(shortViewName.compareTo("GraphDetailView") == 0) {
      return true;
    }
    else {
      return false;
    }
  }
  /**
   * get the name of default view
   * @return the name of default view
   */
  public String getDefaultView() {
    return "fr.unice.javinspector.MVC.view.GraphDetailView";
  }

  public void mouseClicked(MouseEvent e) {
    if (e.getClickCount() == 2) {
      Class keyClass = ( (CustomButton) e.getSource()).getClasse();
      ClassifierAnalyser ca = manager.getInspector().
          getClassifierAnalyser(keyClass.getName());
      try {
        manager.addHeritageView(ca);
      }
      catch(Exception ex) {
        ex.printStackTrace();
      }
    }
  }

  // for that the java compiler being happy :-)
  public void mousePressed(MouseEvent e) {}
  public void mouseEntered(MouseEvent e) {}
  public void mouseExited(MouseEvent e) {}
  public void mouseReleased(MouseEvent e) {}


  public void actionPerformed(ActionEvent e) {
    if (e.getActionCommand().compareTo("MenuItem") == 0) {
      JMenuItem source = (JMenuItem) (e.getSource());
      if (source.getText().compareTo("Save as ...") == 0) {
        // a mettre ici
        SaveFileXML.save(file, detailView.getClassifierAnalyser());
      }
      if (source.getText().compareTo("Refresh view") == 0) {
        ((GraphDetailView)detailView).setField(detailView.getClassifierAnalyser().getField());
        ((GraphDetailView)detailView).getJPanelFields().removeAll();
        ((GraphDetailView)detailView).getJPanelStaticFields().removeAll();
        ((GraphDetailView)detailView).initializeJPanelFields();
        listenToView();
      }
      else;
    }
    else if (e.getActionCommand().compareTo("CheckBox") == 0) {
      JCheckBox js = (JCheckBox) e.getSource();
      changeView(js);
    }
  }

  public void changeView(JCheckBox jcb) {
    if (jcb == ((GraphDetailView)detailView).getJCheckBoxFields()) {
      if (jcb.isSelected()) {
        ((GraphDetailView)detailView).getJPanelFields().setVisible(true);
      }
      else {
        ((GraphDetailView)detailView).getJPanelFields().setVisible(false);
      }
    }
    else if (jcb == ((GraphDetailView)detailView).getJCheckBoxConstructors()) {
      if (jcb.isSelected()) {
        ((GraphDetailView)detailView).getJPanelConstructors().setVisible(true);
      }
      else {
        ((GraphDetailView)detailView).getJPanelConstructors().setVisible(false);
      }
    }
    else if (jcb == ((GraphDetailView)detailView).getJCheckBoxMethods()) {
      if (jcb.isSelected()) {
        ((GraphDetailView)detailView).getJPanelMethods().setVisible(true);
      }
      else {
        ((GraphDetailView)detailView).getJPanelMethods().setVisible(false);
      }
    }
    else if (jcb == ((GraphDetailView)detailView).getJCheckBoxStaticFields()) {
      if (jcb.isSelected()) {
        ((GraphDetailView)detailView).getJPanelStaticFields().setVisible(true);
      }
      else {
        ((GraphDetailView)detailView).getJPanelStaticFields().setVisible(false);
      }
    }
    else if (jcb == ((GraphDetailView)detailView).getJCheckBoxInternalClasses()) {
      if (jcb.isSelected()) {
        ((GraphDetailView)detailView).getJPanelInternalClasses().setVisible(true);
      }
      else {
        ((GraphDetailView)detailView).getJPanelInternalClasses().setVisible(false);
      }
    }
    else if (jcb == ((GraphDetailView)detailView).getJCheckBoxStaticMethods()) {
      if (jcb.isSelected()) {
        ((GraphDetailView)detailView).getJPanelStaticMethods().setVisible(true);
      }
      else {
        ((GraphDetailView)detailView).getJPanelStaticMethods().setVisible(false);
      }
    }
    else if (jcb == ((GraphDetailView)detailView).getJCheckBoxAbstractMethod()) {
      if (jcb.isSelected()) {
        ((GraphDetailView)detailView).getJPanelAbstractMethod().setVisible(true);
      }
      else {
        ((GraphDetailView)detailView).getJPanelAbstractMethod().setVisible(false);
      }
    }
    else if (jcb == ((GraphDetailView)detailView).getJCheckBoxGetterMethods()) {
      if (jcb.isSelected()) {
        ((GraphDetailView)detailView).getJPanelGetterMethod().setVisible(true);
      }
      else {
        ((GraphDetailView)detailView).getJPanelGetterMethod().setVisible(false);
      }
    }
    else if (jcb == ((GraphDetailView)detailView).getJCheckBoxSetterMethods()) {
      if (jcb.isSelected()) {
        ((GraphDetailView)detailView).getJPanelSetterMethods().setVisible(true);
      }
      else {
        ((GraphDetailView)detailView).getJPanelSetterMethods().setVisible(false);
      }
    }
    else if (jcb == ((GraphDetailView)detailView).getJCheckBoxRedefinedMethods()) {
      if (jcb.isSelected()) {
        ((GraphDetailView)detailView).getJPanelRedefinedMethods().setVisible(true);
      }
      else {
        ((GraphDetailView)detailView).getJPanelRedefinedMethods().setVisible(false);
      }
    }
  }

  // a small internal class
  class PopupListener
      extends MouseAdapter {
    public void mousePressed(MouseEvent e) {
      e.getComponent().requestFocus();
      maybeShowPopup(e);
    }

    public void mouseReleased(MouseEvent e) {
      maybeShowPopup(e);
    }

    private void maybeShowPopup(MouseEvent e) {
      if (e.isPopupTrigger()) {
       jPopupMenu.show(e.getComponent(), e.getX(), e.getY());
      }
    }
  }
}
