package fr.unice.javinspector.MVC.controler;

import fr.unice.javinspector.MVC.view.MyCompositionView;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JButton;
import javax.swing.JPanel;
import fr.unice.javinspector.GUI.util.CustomButton;
import javax.swing.JOptionPane;
import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;
import fr.unice.javinspector.MVC.manager.Manager;
import fr.unice.javinspector.MVC.view.View;
import java.util.ArrayList;
import fr.unice.javinspector.core.analyser.ClassifierAnalyser;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class MyCompositionControler extends CompositionControler
    implements ActionListener, MouseListener {
  private MyCompositionView view;
  private MyBoolean isConstructorParameterVisible = new MyBoolean(true);
  private MyBoolean isConstructorExceptionVisible = new MyBoolean(true);
  private MyBoolean isMethodReurnVisible = new MyBoolean(true);
  private MyBoolean isMethodParameterVisible = new MyBoolean(true);
  private MyBoolean isMethodExceptionVisible = new MyBoolean(true);
  private MyBoolean isFieldVisible = new MyBoolean(true);

  /**
   * the default constructor
   */
  public MyCompositionControler() {}

  /**
   * the constructor with a Manager and the View
   * @param m the manager that manage this view
   * @param mcv the view that use this controler
   */
  public MyCompositionControler(Manager m, View mcv) {
    compositionView = (MyCompositionView)mcv;
    manager = m;
    listenToView();
  }

  /**
   * this function add all the listener to all the graphics elements
   */
  public void listenToView() {
    ArrayList listenedJButtons = ((MyCompositionView)compositionView).getListenedJButton();
    for(int i=0; i<listenedJButtons.size(); i++) {
      ((JButton)listenedJButtons.get(i)).addMouseListener(this);
    }
    ((MyCompositionView)compositionView).getJButtonConstructorException().addMouseListener(this);
    ((MyCompositionView)compositionView).getJButtonConstructorException().addActionListener(this);
    ((MyCompositionView)compositionView).getJButtonConstructorException().setActionCommand("MyJButton");

    ((MyCompositionView)compositionView).getJButtonConstructorParameter().addMouseListener(this);
    ((MyCompositionView)compositionView).getJButtonConstructorParameter().addActionListener(this);
    ((MyCompositionView)compositionView).getJButtonConstructorParameter().setActionCommand("MyJButton");

    ((MyCompositionView)compositionView).getJButtonField().addMouseListener(this);
    ((MyCompositionView)compositionView).getJButtonField().addActionListener(this);
    ((MyCompositionView)compositionView).getJButtonField().setActionCommand("MyJButton");

    ((MyCompositionView)compositionView).getJButtonMethodException().addMouseListener(this);
    ((MyCompositionView)compositionView).getJButtonMethodException().addActionListener(this);
    ((MyCompositionView)compositionView).getJButtonMethodException().setActionCommand("MyJButton");

    ((MyCompositionView)compositionView).getJButtonMethodsParameter().addMouseListener(this);
    ((MyCompositionView)compositionView).getJButtonMethodsParameter().addActionListener(this);
    ((MyCompositionView)compositionView).getJButtonMethodsParameter().setActionCommand("MyJButton");

    ((MyCompositionView)compositionView).getJButtonMethodsReturType().addMouseListener(this);
    ((MyCompositionView)compositionView).getJButtonMethodsReturType().addActionListener(this);
    ((MyCompositionView)compositionView).getJButtonMethodsReturType().setActionCommand("MyJButton");
  }

  /**
   * this function returns the name of the String
   * @return the name of the class
   */
  public String getName() {
    return this.getClass().getName();
  }

  /**
   * tests the given view for compatibility with this controler
   * @param v the view to test
   * @return true the view is compatible, false otherwise
   */
  public boolean isControlable(View v) {
    String shortViewName = v.getName().substring(v.getName().lastIndexOf("."), v.getName().length());
    if(shortViewName.compareTo("MyCompositionView") == 0) {
      return true;
    }
    else {
      return false;
    }
  }

  /**
   * @return the name of the default view
   */
  public String getDefaultView() {
    return "fr.unice.javinspector.MVC.controler.MyCompositionControler";
  }

  /**
   * the mouse clicked Event
   * @param e the MouseEvent
   */
  public void mouseClicked(MouseEvent e) {
    if (e.getClickCount() == 2 && e.getSource() instanceof CustomButton) {
      Class keyClass = ( (CustomButton) e.getSource()).getClasse();
      if (keyClass.isPrimitive()) {
        JOptionPane.showMessageDialog(manager.getTopManager().getViewContainer(),
                                      "Sorry, but " + keyClass +
                                      " is a primitive class.",
                                      "Heritage view information message",
                                      JOptionPane.INFORMATION_MESSAGE);
      }
      else {
        ClassifierAnalyser ca = manager.getInspector().getClassifierAnalyser(
            keyClass.getName());
        try {
          manager.addHeritageView(ca);
        }
        catch (Exception ex) {
          ex.printStackTrace();
        }
      }
    }
  }

  public void mousePressed(MouseEvent e) {};

  /**
   * the enterred mouse event
   * @param e the MouseEvent
   */
  public void mouseEntered(MouseEvent e) {
    if (((JButton)e.getSource()).getActionCommand().compareTo("MyJButton") == 0) {
      ((JButton)e.getSource()).setBorderPainted(true);
    }
  }

  /**
   * the mouse exited event
   * @param e the MouseEvent
   */
  public void mouseExited(MouseEvent e) {
    if (((JButton)e.getSource()).getActionCommand().compareTo("MyJButton") == 0) {
      ((JButton)e.getSource()).setBorderPainted(false);
    }
  }

  /**
   * the mouse released event
   * @param e the MouseEvent
   */
  public void mouseReleased(MouseEvent e) {};

  /**
   * the actionPerformed function
   * @param e the ActionEvent
   */
  public void actionPerformed(ActionEvent e) {
    MyCompositionView view = (MyCompositionView)compositionView;
    if (e.getActionCommand().compareTo("MyJButton") == 0) {
      JButton jb = (JButton) e.getSource();
      if (jb == view.getJButtonConstructorParameter()) {
        applyEvent(isConstructorParameterVisible,
                   view.getJPanelConstructorParameter(), jb);
      }
      else if (jb == view.getJButtonConstructorException()) {
        applyEvent(isConstructorExceptionVisible,
                   view.getJPanelConstructorException(), jb);
      }
      else if (jb == view.getJButtonMethodsParameter()) {
        applyEvent(isMethodParameterVisible, view.getJPanelMethodParameter(),
                   jb);
      }
      else if (jb == view.getJButtonMethodsReturType()) {
        applyEvent(isMethodReurnVisible, view.getJPanelMethodReturn(), jb);
      }
      else if (jb == view.getJButtonMethodException()) {
        applyEvent(isMethodExceptionVisible, view.getJPanelMethodException(),
                   jb);
      }
      else if (jb == view.getJButtonField()) {
        applyEvent(isFieldVisible, view.getJPanelTypeField(), jb);
      }
    }
  }

  public void applyEvent(MyBoolean bool, JPanel jPanel, JButton jb) {
    MyCompositionView view = (MyCompositionView)compositionView;
    if (bool.getValue() == true) {
      jPanel.setVisible(false);
      bool.setValue(false);
      jb.setIcon(view.getFlecheBas());
      jb.setToolTipText("open this panel");
      view.changeSize();
    }
    else {
      jPanel.setVisible(true);
      bool.setValue(true);
      jb.setIcon(view.getFlecheHaut());
      jb.setToolTipText("close this panel");
      view.changeSize();

    }
  }

  // a small litle class for using boolean like an object
  // because in the Boolean class there is not Set function
  class MyBoolean {
    private boolean value;
    MyBoolean(boolean value) {
      this.value = value;
    }

    public void setValue(boolean value) {
      this.value = value;
    }

    public boolean getValue() {
      return this.value;
    }
  }

}
