package fr.unice.javinspector.MVC.manager;

import fr.unice.javinspector.plugin.*;
import java.awt.Container;
import fr.unice.javinspector.MVC.view.*;
import java.util.Hashtable;
import javax.swing.ImageIcon;
import javax.swing.JPanel;
import java.awt.BorderLayout;
import javax.swing.JLabel;
import java.awt.FlowLayout;
import fr.unice.javinspector.GUI.util.JTabbedPaneWithCloseIcons;
import fr.unice.javinspector.core.analyser.ClassifierAnalyser;
import fr.unice.javinspector.MVC.controler.DetailControler;
import fr.unice.javinspector.MVC.controler.AbstractControler;
import javax.swing.JOptionPane;
import java.awt.SystemColor;
import java.awt.Dimension;
import javax.swing.BorderFactory;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Charbit Lucas - Gahide Jrome - Galbois Xavier - Zerbib Gabriel
 * @version 1.0
 */

public class TabbedPaneDetailManager extends AbstractManager {
  private Hashtable controlersViews = new Hashtable();
  private int index = 0;
  // **** GUI OBJECTS ****
  // the icons for the tabbedPane
  private JPanel globalPanel = new JPanel();
  private BorderLayout borderLayout1 = new BorderLayout();
  private JPanel jPanelNbViews = new JPanel();
  private JLabel jLabelNbViews = new JLabel();
  private FlowLayout flowLayout1 = new FlowLayout();
  private JTabbedPaneWithCloseIcons jTabbedPaneDetailView = new JTabbedPaneWithCloseIcons();


  public String getName() {
    return this.getClass().getName();
  }

  public Container getViewContainer() {
    return globalPanel;
  }

  public TabbedPaneDetailManager(Manager topManager) {
    super(topManager);
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    // the first view
    this.addDetailView(this.getInspector().getMainClassifier());
  }

  public void addDetailView(ClassifierAnalyser ca) {
    Class detailViewClass = this.getPlugin(PluginTypes.DETAIL_VIEW);
    Class detailControlerClass = this.getPlugin(PluginTypes.DETAIL_CONTROLER);
    DetailView dv = null;
    DetailControler dc = null;
    try {
      dv = (DetailView)AbstractView.create(detailViewClass, ca);
      dc = (DetailControler)AbstractControler.create(detailControlerClass, this, dv);
    }
    catch(Exception e) {
      e.printStackTrace();
      JOptionPane.showMessageDialog(this.getViewContainer(), "Can't create view",
                                    "Detail view creation error message", JOptionPane.ERROR_MESSAGE);
      return;
    }
    controlersViews.put(dc, dv);
    String classifierName = ca.getClassAnalysed().getName();
    String shortClassifiername = ClassifierAnalyser.shortName(classifierName);
    String modifier = ca.modifierToString();
    if(ca.getClassAnalysed().isInterface()) {
      jTabbedPaneDetailView.addTab(shortClassifiername, dv.getViewContainer());
      jTabbedPaneDetailView.setToolTipTextAt(index, modifier + " " + classifierName);
    }
    else {
      jTabbedPaneDetailView.addTab(shortClassifiername, dv.getViewContainer());
      jTabbedPaneDetailView.setToolTipTextAt(index, modifier + " Class " + classifierName);
    }
  }

  // init by JBuilder DON'T EDIT !
  private void jbInit() throws Exception {
    globalPanel.setLayout(borderLayout1);
    jPanelNbViews.setLayout(flowLayout1);
    jLabelNbViews.setToolTipText("The number of classifier opened");
    flowLayout1.setAlignment(FlowLayout.LEFT);
    jTabbedPaneDetailView.setBorder(null);
    jTabbedPaneDetailView.setMaximumSize(new Dimension(32767, 32767));
    globalPanel.setBackground(SystemColor.control);
    jPanelNbViews.setBorder(BorderFactory.createEtchedBorder());
    globalPanel.add(jPanelNbViews, BorderLayout.NORTH);
    jPanelNbViews.add(jLabelNbViews, null);
    globalPanel.add(jTabbedPaneDetailView, BorderLayout.CENTER);
  }
}
