package fr.unice.javinspector.core.XML;

import java.io.ByteArrayInputStream;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import java.io.FileInputStream;
import java.io.File;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.Transformer;
import javax.xml.transform.stream.StreamSource;
import javax.xml.transform.stream.StreamResult;
import org.xml.sax.SAXException;
import java.io.BufferedReader;
import java.io.FileReader;
import javax.swing.JOptionPane;

/**
 * <p>Title: TransformFile </p>
 * <p>Description: this class allows to transform a XML file in .txt File</p>
 * <p>Company: UNSA</p>
 * @author Lucas Charbit - Jerome Gahide - Galbois Xavier - Gabriel Zerbib
 * @version 1.0
 */
public class TransformFile {

  /**
   * this function transform the file fileXML in file name with the file
   * fileXSL
   * @param fileXML the name of the to transform
   * @param name the name of result file
   * @param fileXSL the name of XSL file
   * @return a new File transformed
   * @throws Exception
   */
  public static boolean transform(File fileXML,File name,File fileXSL) throws Exception{

  DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
  factory.setNamespaceAware(true);

  try {
    DocumentBuilder builder = factory.newDocumentBuilder();
    Document doc = builder.parse(fileXML);

    if (doc!=null){
      FileInputStream stylesheet = null;
      File sourceId = null;

      stylesheet = new FileInputStream(fileXSL);

      DOMSource xmlSource = new DOMSource(doc);

      TransformerFactory tf = TransformerFactory.newInstance();
      Transformer transformer = tf.newTransformer(new StreamSource(stylesheet));

      transformer.transform(xmlSource,new StreamResult(name));
    }
    return true;
  }
  catch(SAXException e){
    System.err.println("ERROR 1");
    JOptionPane.showMessageDialog(null,"Your xml file seems to be corrupted");
    return false;
  }
  catch(Exception e){
    System.err.println("ERROR 2");
    JOptionPane.showMessageDialog(null,"Your xsl file seems to be corrupted");
    return false;
  }
}
}

