package fr.unice.javinspector.core.analyser;

/**
 *
 * <p>Title: TypeClass</p>
 * <p>Description: gets the real name of a class which is an array</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: UNSA</p>
 * @author Jerme GAHIDE - Lucas CHARBIT - Gabriel ZERBIB - Xavier GALBOIS
 * @version 1.0
 */
public class TypeClass {

  private String name;
  private Class cl;
  private int dimension;

  /**
   * Default constructor
   * @param name the real name of the class
   * @param cl the class
   * @param theDimension the dimension of the array (O if it isn't an array)
   */
  public TypeClass(String name , Class cl, int theDimension) {
    this.name = name;
    this.cl = cl;
    this.dimension = theDimension;
  }


  /**
   * get the Class object
   * @return the Class object
   */
  public Class getCl() {
    return cl;
  }

  /**
   *
   * @return true if the contained class is an array false either
   */
  public boolean isArray() {
    return (dimension != 0);
  }

  /**
   * gets the dimension of class contained (O if it isn't an array)
   * @return the dimension
   */
  public int getDimension(){
    return dimension;
  }

  /**
   * gets the real name of the contained class
   * @return the name
   */
  public String getName() {
    return name;
  }
}
