package fr.unice.javinspector.core.engineSearch;

import java.lang.reflect.*;

/**
 * <p>Title: ConstructorCriterion</p>
 * <p>Description:the criterion that test if the member is a constructor </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: UNICE</p>
 * @author Zerbib Gabriel - Charbit Lucas - Galbois Xavier - Gahide Jrme
 * @version 1.0
 */

public class ConstructorCriterion extends Criterion {


  /**
   * Construct a new instance of this criterion.
   * This overwrite the name of the criterion
   */
  public ConstructorCriterion() {
    name = "constructor";
  }


  /**
   * test if the member matches to this criterion.
   * @param m the member that we want to check the validity.
   * @return true if the Criterion is Valid for this Member
   * @throws SearchEngineException
   */
  public boolean isCriterionValid(Member m) throws fr.unice.javinspector.core.engineSearch.SearchEngineException {
    if( isActive == EngineSearchConst.NOT){
      if( !(m instanceof Constructor) )
        return true;
      else return false;
    }
    else if( isActive == EngineSearchConst.YES){
      if( m instanceof Constructor )
        return true;
      else return false;
    }
    else if( isActive == EngineSearchConst.DONTMIND){
      // if i don't mind of the result, I always return true
      // logic !!
      return true;
    }
    else{
      throw new SearchEngineException("isCriterionValid : Constructor Criterion : ");
    }
  }
}
