package fr.unice.javinspector.core.engineSearch;

import java.lang.reflect.*;

/**
 * <p>Title: SynchronizedCriterion</p>
 * <p>Description: the criterion that test if the member is synchronized </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: UNSA</p>
 * @author Zerbib Gabriel - Charbit Lucas - Galbois Xavier - Gahide Jrme
 * @version 1.0
 */

public class SynchronizedCriterion extends Criterion {

  public SynchronizedCriterion() {
    this.name = "synchronized";
  }

  public boolean isCriterionValid(Member m) throws fr.unice.javinspector.core.engineSearch.SearchEngineException {
    if( isActive == EngineSearchConst.NOT){
            return !Modifier.isSynchronized(m.getModifiers());
          }
          else if( isActive == EngineSearchConst.YES){
            return Modifier.isSynchronized(m.getModifiers());
          }
          else if( isActive == EngineSearchConst.DONTMIND){
            // if i don't mind of the result, I always return true
            // logic !!
            return true;
          }
          else{
           throw new SearchEngineException("isCriterionValid : Synchronized Criterion : ");
       }
  }
}
