package fr.unice.javinspector.plugin;

/**
 * <p>Title: Interface Plugin</p>
 * <p>Description: Interface Plugin must be implemented by any plugin</p>
 * <pre> Note that a plugin must have the default constructor with no
 * parameter</per>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Jerme GAHIDE - Lucas CHARBIT - Gabriel ZERBIB - Xavier GALBOIS
 * @version 1.0
 */

public interface Plugin {
  /**
   * returns the name of the plugin
   * @return the name of the plugin
   */
  public String getName();

  /**
   * return the type of the Plugin
   * @return the type of the Plugin
   * @see fr.unice.javinspector.plugin.PluginTypes
   */
  public int getType();
}
